Class | Chef::EncryptedDataBagItem
In: | lib/chef/encrypted_data_bag_item.rb
Parent: | Object

An EncryptedDataBagItem represents a read-only data bag item where all values, except for the value associated with the id key, have been encrypted.

EncrypedDataBagItem can be used in recipes to decrypt data bag item members.

Data bag item values are assumed to have been encrypted using the default symmetric encryption provided by Encryptor.encrypt where values are converted to YAML prior to encryption.

If the shared secret is not specified at initialization or load, then the contents of the file referred to in Chef::Config[:encrypted_data_bag_secret] will be used as the secret. The default path is /etc/chef/encrypted_data_bag_secret

EncryptedDataBagItem is intended to provide a means to avoid storing data bag items in the clear on the Chef server. This provides some protection against a breach of the Chef server or of Chef server backup data. Because the secret must be stored in the clear on any node needing access to an EncryptedDataBagItem, this approach provides no protection of data bag items from actors with access to such nodes in the infrastructure.

### Methods

[] []= cipher decrypt_value encrypt_data_bag_item encrypt_value from_plain_hash load load_secret new to_hash

### Constants

DEFAULT_SECRET_FILE | = | "/etc/chef/encrypted_data_bag_secret"
ALGORITHM | = | 'aes-256-cbc'

### Public Class methods

decrypt_value(value, key)
encrypt_data_bag_item(plain_hash, secret)
encrypt_value(value, key)
from_plain_hash(plain_hash, secret)
load(data_bag, name, secret = nil)
load_secret(path=nil)
new(enc_hash, secret)

### Protected Class methods

cipher(direction, data, key)

### Public Instance methods

[](key)
[]=(key, value)
to_hash()

[Validate]